/*******************************************************************************
*  skDEBUG - PICUSARTɂăfobOj^[s֐Cu[              *
*                                                                              *
*  note : ̃vOɂskUARTlib.c/skUARTlib.hKvłB                *
*         j^[̓p\RŃVAʐM(COM)\łc[ōs܂B  *
*         ڑ́APIC-(USART)-MAX232-(RS232C)-PC(COM)-VAʐM\c[   *
*                 PIC-(USART)-FT232R-(USB)-PC(COMϊ)-VAʐM\c[  *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2013-01-22  ޒH[(ނ)  Create                            *
* ============================================================================ *
*  MPLAB IDE(V8.84)                                                            *
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*******************************************************************************/
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "skDEBUG.h"
#include "skUARTlib.h"

/*******************************************************************************
*  DEBUG_PutChar(c)/UART2PrintString(c)                                        *
*    fobOj^[ɂPoCg̃f[^𑗐M鏈                          *
*                                                                              *
*    c : MPoCg̐lw肵܂                                    *
*******************************************************************************/
void DEBUG_PutChar(const char c)
{
     UART_Write((char)c) ;
}
/*******************************************************************************
*  DEBUG_PutString(s)                                                          *
*    fobOj^[ɕ𑗐M鏈                                    *
*                                                                              *
*    s : \镶w肵܂iNULL܂ŏój                            *
*******************************************************************************/
void DEBUG_PutString(const char * s)
{
     int n ;

     n = strlen(s) ;    // ̒𒲂ׂ
     UART_Send(s,n) ;
}
void UART2PrintString(const char * s)
{
     DEBUG_PutString(s) ;
}
/*******************************************************************************
*  DEBUG_PutHexUINT8(c)                                                        *
*    fobOj^[ɂPUiőM鏈                                  *
*    PoCg̐lPUiɕϊăj^[֏o͂܂                  *
*                                                                              *
*    c : \PoCg̐lw肵܂                                    *
*                                                                              *
*******************************************************************************/
void DEBUG_PutHexUINT8(unsigned char c)
{
     const char HEX_Data[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'} ;

     UART_Write(HEX_Data[ c >> 4 ]) ;
     UART_Write(HEX_Data[ c & 0x0F ]) ;
}
void UART2PutHex(unsigned char c)
{
     DEBUG_PutHexUINT8(c) ;
}
/*******************************************************************************
*  UART2PutDec(d)                                                              *
*    fobOj^[ɂPOiőM鏈                                  *
*    PoCg̐lPOiɕϊăj^[֏o͂܂                  *
*                                                                              *
*    d : \PoCg̐lw肵܂                                    *
*                                                                              *
*******************************************************************************/
void UART2PutDec(unsigned char d)
{
     char buf[6] ;

     sprintf(buf,"%d",d) ;
     DEBUG_PutString(buf) ;
}




/*******************************************************************************
*  MonitorPutb(c)                                                              *
*    fobOj^[ɂQiőM鏈                                    *
*    PoCg̐lQiɕϊăj^[֏o͂܂                    *
*                                                                              *
*    c : \PoCg̐lw肵܂                                    *
*                                                                              *
*******************************************************************************/
void MonitorPutb(unsigned char c)
{
     int i ;

     for (i=7 ; i>=0 ; i--) {
          if ( ((c >> i) & 0x1) == 1) UART_Write('1') ;
          else                        UART_Write('0') ;
     }
}
