/*******************************************************************************
*  skUARTlib.h - UARTʐMs֐̃CN[ht@C(16rbgMCUp)     *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY                    CHANGE/COMMENT                  *
* ---------------------------------------------------------------------------- *
*   1.00     2015-09-01  ޒH[(ނ)  Create                          *
*   2.00     2019-01-07  ޒH[(ނ)  PIC24FΉ,peBΉ         *
*******************************************************************************/
#ifndef _SKUARTLIB_H_
#define _SKUARTLIB_H_

// __delay_ms__delay_usƃ{[[ǧvZɕKv
#ifndef FCY
  // Unless already defined assume 32MHz(16MIPS) system frequency
  #define FCY 16000000UL           // Fosc/2(16MIPS)
  #include <libpic30.h>
#endif

#define UART_8N1                   // Data=8bit Parity=none Stop=1bit Flow=none (W)
//#define UART_8O1                   // Data=8bit Parity=0dd Stop=1bit Flow=none (peBL))
//#define UART_8E1                   // Data=8bit Parity=Even Stop=1bit Flow=none (peBL))

#define UART_BUFFER_SIZE   64      // t`qs̎Mobt@TCY

//#define UART2_USE                  // UART2𗘗pꍇ̓RgO܂B
// t`qsW[̃WX^[`
#ifdef  UART2_USE
// UARTQ𗘗pꍇ̒`
#define UMODE   U2MODE
#define USTA    U2STA
#define UARTEN  U2MODEbits.UARTEN
#define UTXEN   U2STAbits.UTXEN
#define UBRGH   U2MODEbits.BRGH
#define PDSEL   U2MODEbits.PDSEL
#define STSEL   U2MODEbits.STSEL
#define UBRG    U2BRG
#define UTXREG  U2TXREG
#define UTXIF   _U2TXIF
#define UTXIE   _U2TXIE
#define UTXIP   _U2TXIP
#define UTXBF   U2STAbits.UTXBF
#define URXDA   U2STAbits.URXDA
#define URXOERR U2STAbits.OERR
#define URXREG  U2RXREG
#define URXIF   _U2RXIF
#define URXIE   _U2RXIE
#define URXIP   _U2RXIP
#if defined(__PIC24E__)
#define UEIF    _U2EIF
#define UEIE    _U2EIE
#define UEIP    _U2EIP
#else
#define UEIF    _U2ERIF
#define UEIE    _U2ERIE
#define UEIP    _U2ERIP
#endif
#else
// UARTP𗘗pꍇ̒`
#define UMODE   U1MODE
#define USTA    U1STA
#define UARTEN  U1MODEbits.UARTEN
#define UTXEN   U1STAbits.UTXEN
#define UBRGH   U1MODEbits.BRGH
#define PDSEL   U1MODEbits.PDSEL
#define STSEL   U1MODEbits.STSEL
#define UBRG    U1BRG
#define UTXREG  U1TXREG
#define UTXIF   _U1TXIF
#define UTXIE   _U1TXIE
#define UTXIP   _U1TXIP
#define UTXBF   U1STAbits.UTXBF
#define URXDA   U1STAbits.URXDA
#define URXOERR U1STAbits.OERR
#define URXREG  U1RXREG
#define URXIF   _U1RXIF
#define URXIE   _U1RXIE
#define URXIP   _U1RXIP
#if defined(__PIC24E__)
#define UEIF    _U1EIF
#define UEIE    _U1EIE
#define UEIP    _U1EIP
#else
#define UEIF    _U1ERIF
#define UEIE    _U1ERIE
#define UEIP    _U1ERIP
#endif
#endif

// ֐̃vg^Cv錾
void InitUART(int rx, int tx, long brg) ;
void UART_Send(const char *dt,int num) ;
void UART_Write(char dt) ;
int  UART_Available() ;
unsigned int UART_Read() ;
void UART_Flush() ;

#endif
